diff --git a/buffer.c b/buffer.c
index 869e6a3..b82ea3c 100644
--- a/buffer.c
+++ b/buffer.c
@@ -85,9 +85,13 @@ void
 nettle_buffer_clear(struct nettle_buffer *buffer)
 {
   if (buffer->realloc)
-    buffer->realloc(buffer->realloc_ctx, buffer->contents, 0);
+    buffer->contents = buffer->realloc(buffer->realloc_ctx, buffer->contents, 0);
 
-  buffer->contents = NULL;
+  if (buffer->contents)
+    {
+      free(buffer->contents);
+      buffer->contents = NULL;
+    }
   buffer->alloc = 0;
   buffer->size = 0;
 }
diff --git a/examples/rsa-encrypt.c b/examples/rsa-encrypt.c
index 70d1503..ca1a8cd 100644
--- a/examples/rsa-encrypt.c
+++ b/examples/rsa-encrypt.c
@@ -253,7 +253,9 @@ main(int argc, char **argv)
     }
 
   write_bignum(stdout, x);
-  
+
+  mpz_clear(x);
+
   if (!process_file(&ctx,
 		    stdin, stdout))
     return EXIT_FAILURE;
diff --git a/examples/rsa-keygen.c b/examples/rsa-keygen.c
index 0ca39b4..165e6f4 100644
--- a/examples/rsa-keygen.c
+++ b/examples/rsa-keygen.c
@@ -160,5 +160,12 @@ main(int argc, char **argv)
       return EXIT_FAILURE;
     }
 
+  nettle_buffer_clear(&pub_buffer);
+  nettle_buffer_clear(&priv_buffer);
+  rsa_private_key_clear(&priv);
+  rsa_public_key_clear(&pub);
+  free(pub_name);
+
+
   return EXIT_SUCCESS;
 }
diff --git a/testsuite/aes-test.c b/testsuite/aes-test.c
index 87be806..aa9bf59 100644
--- a/testsuite/aes-test.c
+++ b/testsuite/aes-test.c
@@ -2,10 +2,16 @@
 #include "aes.h"
 
 static void
-test_invert(unsigned key_length, const uint8_t *key,
-	    unsigned length, const uint8_t *cleartext,
-	    const uint8_t *ciphertext)
+test_invert(const uint8_t *key_hex,
+	    const uint8_t *cleartext_hex,
+	    const uint8_t *ciphertext_hex)
 {
+  unsigned key_length = decode_hex_length(key_hex);
+  const uint8_t *key = decode_hex_dup(key_hex);
+  unsigned length = decode_hex_length(cleartext_hex);
+  const uint8_t *cleartext = decode_hex_dup(cleartext_hex);
+  const uint8_t *ciphertext = decode_hex_dup(ciphertext_hex);
+
   struct aes_ctx encrypt;
   struct aes_ctx decrypt;
   uint8_t *data = xalloc(length);
@@ -39,61 +45,65 @@ test_invert(unsigned key_length, const uint8_t *key,
       fprintf(stderr, "\n");
       FAIL();
     }
+
   free (data);
+  free((void *)ciphertext);
+  free((void *)cleartext);
+  free((void *)key);
 }
 
 int
 test_main(void)
 {
   /* 128 bit keys */
-  test_cipher(&nettle_aes128, 
-	      HL("0001020305060708 0A0B0C0D0F101112"),
-	      HL("506812A45F08C889 B97F5980038B8359"),
-	      H("D8F532538289EF7D 06B506A4FD5BE9C9"));
+  test_cipher(&nettle_aes128,
+	      "0001020305060708 0A0B0C0D0F101112",
+	      "506812A45F08C889 B97F5980038B8359",
+	      "D8F532538289EF7D 06B506A4FD5BE9C9");
   
   test_cipher(&nettle_aes128, 
-	      HL("14151617191A1B1C 1E1F202123242526"),
-	      HL("5C6D71CA30DE8B8B 00549984D2EC7D4B"),
-	      H("59AB30F4D4EE6E4F F9907EF65B1FB68C"));
+	      "14151617191A1B1C 1E1F202123242526",
+	      "5C6D71CA30DE8B8B 00549984D2EC7D4B",
+	      "59AB30F4D4EE6E4F F9907EF65B1FB68C");
 
   test_cipher(&nettle_aes128, 
-	      HL("28292A2B2D2E2F30 323334353738393A"),
-	      HL("53F3F4C64F8616E4 E7C56199F48F21F6"),
-	      H("BF1ED2FCB2AF3FD4 1443B56D85025CB1"));
+	      "28292A2B2D2E2F30 323334353738393A",
+	      "53F3F4C64F8616E4 E7C56199F48F21F6",
+	      "BF1ED2FCB2AF3FD4 1443B56D85025CB1");
   
   test_cipher(&nettle_aes128, 
-	      HL("A0A1A2A3A5A6A7A8 AAABACADAFB0B1B2"),
-	      HL("F5F4F7F684878689 A6A7A0A1D2CDCCCF"),
-	      H("CE52AF650D088CA5 59425223F4D32694"));
+	      "A0A1A2A3A5A6A7A8 AAABACADAFB0B1B2",
+	      "F5F4F7F684878689 A6A7A0A1D2CDCCCF",
+	      "CE52AF650D088CA5 59425223F4D32694");
 
   /* 192 bit keys */
   
   test_cipher(&nettle_aes192, 
-	      HL("0001020305060708 0A0B0C0D0F101112"
-		"14151617191A1B1C"),
-	      HL("2D33EEF2C0430A8A 9EBF45E809C40BB6"),
-	      H("DFF4945E0336DF4C 1C56BC700EFF837F"));
+	      "0001020305060708 0A0B0C0D0F101112"
+		"14151617191A1B1C",
+	      "2D33EEF2C0430A8A 9EBF45E809C40BB6",
+	      "DFF4945E0336DF4C 1C56BC700EFF837F");
 
   /* 256 bit keys */
   
   test_cipher(&nettle_aes256,
-	      HL("0001020305060708 0A0B0C0D0F101112"
-		"14151617191A1B1C 1E1F202123242526"),
-	      HL("834EADFCCAC7E1B30664B1ABA44815AB"),
-	      H("1946DABF6A03A2A2 C3D0B05080AED6FC"));
+	      "0001020305060708 0A0B0C0D0F101112"
+		"14151617191A1B1C 1E1F202123242526",
+	      "834EADFCCAC7E1B30664B1ABA44815AB",
+	      "1946DABF6A03A2A2 C3D0B05080AED6FC");
 
   
   /* This test case has been problematic with the CBC test case */
   test_cipher(&nettle_aes256,
-	      HL("8d ae 93 ff fc 78 c9 44"
+	      "8d ae 93 ff fc 78 c9 44"
 		"2a bd 0c 1e 68 bc a6 c7"
 		"05 c7 84 e3 5a a9 11 8b"
-		"d3 16 aa 54 9b 44 08 9e"),
-	      HL("a5 ce 55 d4 21 15 a1 c6 4a a4 0c b2 ca a6 d1 37"),
+		"d3 16 aa 54 9b 44 08 9e",
+	      "a5 ce 55 d4 21 15 a1 c6 4a a4 0c b2 ca a6 d1 37",
 	      /* In the cbc test, I once got the bad value
 	       *   "b2 a0 6c d2 2f df 7d 2c  26 d2 42 88 8f 20 74 a2" */
-	      H("1f 94 fc 85 f2 36 21 06"
-		"4a ea e3 c9 cc 38 01 0e"));
+	      "1f 94 fc 85 f2 36 21 06"
+		"4a ea e3 c9 cc 38 01 0e");
   
   /* From draft NIST spec on AES modes.
    *
@@ -102,54 +112,54 @@ test_main(void)
    */
 
   test_cipher(&nettle_aes128,
-	      HL("2b7e151628aed2a6abf7158809cf4f3c"),
-	      HL("6bc1bee22e409f96e93d7e117393172a"
+	      "2b7e151628aed2a6abf7158809cf4f3c",
+	      "6bc1bee22e409f96e93d7e117393172a"
 		"ae2d8a571e03ac9c9eb76fac45af8e51"
 		"30c81c46a35ce411e5fbc1191a0a52ef"
-		"f69f2445df4f9b17ad2b417be66c3710"),
-	      H("3ad77bb40d7a3660a89ecaf32466ef97"
+		"f69f2445df4f9b17ad2b417be66c3710",
+	      "3ad77bb40d7a3660a89ecaf32466ef97"
 		"f5d3d58503b9699de785895a96fdbaaf"
 		"43b1cd7f598ece23881b00e3ed030688"
-		"7b0c785e27e8ad3f8223207104725dd4"));
+		"7b0c785e27e8ad3f8223207104725dd4");
 
   /* F.1.3 ECB-AES192-Encrypt */
 
   test_cipher(&nettle_aes192,
-	      HL("8e73b0f7da0e6452c810f32b809079e5 62f8ead2522c6b7b"),
-	      HL("6bc1bee22e409f96e93d7e117393172a"
+	      "8e73b0f7da0e6452c810f32b809079e5 62f8ead2522c6b7b",
+	      "6bc1bee22e409f96e93d7e117393172a"
 		"ae2d8a571e03ac9c9eb76fac45af8e51"
 		"30c81c46a35ce411e5fbc1191a0a52ef"
-		"f69f2445df4f9b17ad2b417be66c3710"),
-	      H("bd334f1d6e45f25ff712a214571fa5cc"
+		"f69f2445df4f9b17ad2b417be66c3710",
+	      "bd334f1d6e45f25ff712a214571fa5cc"
 		"974104846d0ad3ad7734ecb3ecee4eef"
 		"ef7afd2270e2e60adce0ba2face6444e"
-		"9a4b41ba738d6c72fb16691603c18e0e"));
+		"9a4b41ba738d6c72fb16691603c18e0e");
 
   /* F.1.5 ECB-AES256-Encrypt */
   test_cipher(&nettle_aes256,
-	      HL("603deb1015ca71be2b73aef0857d7781"
-		"1f352c073b6108d72d9810a30914dff4"),
-	      HL("6bc1bee22e409f96e93d7e117393172a"
+	      "603deb1015ca71be2b73aef0857d7781"
+		"1f352c073b6108d72d9810a30914dff4",
+	      "6bc1bee22e409f96e93d7e117393172a"
 		"ae2d8a571e03ac9c9eb76fac45af8e51" 
 		"30c81c46a35ce411e5fbc1191a0a52ef"
-		"f69f2445df4f9b17ad2b417be66c3710"),
-	      H("f3eed1bdb5d2a03c064b5a7e3db181f8"
+		"f69f2445df4f9b17ad2b417be66c3710",
+	      "f3eed1bdb5d2a03c064b5a7e3db181f8"
 		"591ccb10d410ed26dc5ba74a31362870"
 		"b6ed21b99ca6f4f9f153e7b1beafed1d"
-		"23304b7a39f9f3ff067d8d8f9e24ecc7"));
+		"23304b7a39f9f3ff067d8d8f9e24ecc7");
 
   /* Test aes_invert_key with src != dst */
-  test_invert(HL("0001020305060708 0A0B0C0D0F101112"),
-	      HL("506812A45F08C889 B97F5980038B8359"),
-	      H("D8F532538289EF7D 06B506A4FD5BE9C9"));
-  test_invert(HL("0001020305060708 0A0B0C0D0F101112"
-		"14151617191A1B1C"),
-	      HL("2D33EEF2C0430A8A 9EBF45E809C40BB6"),
-	      H("DFF4945E0336DF4C 1C56BC700EFF837F"));
-  test_invert(HL("0001020305060708 0A0B0C0D0F101112"
-		"14151617191A1B1C 1E1F202123242526"),
-	      HL("834EADFCCAC7E1B30664B1ABA44815AB"),
-	      H("1946DABF6A03A2A2 C3D0B05080AED6FC"));
+  test_invert("0001020305060708 0A0B0C0D0F101112",
+	      "506812A45F08C889 B97F5980038B8359",
+	      "D8F532538289EF7D 06B506A4FD5BE9C9");
+  test_invert("0001020305060708 0A0B0C0D0F101112"
+		"14151617191A1B1C",
+	      "2D33EEF2C0430A8A 9EBF45E809C40BB6",
+	      "DFF4945E0336DF4C 1C56BC700EFF837F");
+  test_invert("0001020305060708 0A0B0C0D0F101112"
+		"14151617191A1B1C 1E1F202123242526",
+	      "834EADFCCAC7E1B30664B1ABA44815AB",
+	      "1946DABF6A03A2A2 C3D0B05080AED6FC");
 
   SUCCESS();
 }
diff --git a/testsuite/arcfour-test.c b/testsuite/arcfour-test.c
index 6027c54..99a42bb 100644
--- a/testsuite/arcfour-test.c
+++ b/testsuite/arcfour-test.c
@@ -5,16 +5,16 @@ int
 test_main(void)
 {
   test_cipher_stream(&nettle_arcfour128,
-		     HL("01234567 89ABCDEF 00000000 00000000"),
-		     HL("01234567 89ABCDEF"),
-		     H("69723659 1B5242B1"));
+		     "01234567 89ABCDEF 00000000 00000000",
+		     "01234567 89ABCDEF",
+		     "69723659 1B5242B1");
 
   /* More data. This ensures that we get some collisions between the S
      accesses at index i,j and the access at si + sj. I.e. the cases
      where the ordering of loads and stores matter. */
   test_cipher_stream(&nettle_arcfour128,
-		     HL("aaaaaaaa bbbbbbbb cccccccc dddddddd"),
-		     HL("00000000 00000000 00000000 00000000"
+		     "aaaaaaaa bbbbbbbb cccccccc dddddddd",
+		     "00000000 00000000 00000000 00000000"
 			"00000000 00000000 00000000 00000000"
 			"00000000 00000000 00000000 00000000"
 			"00000000 00000000 00000000 00000000"
@@ -52,8 +52,8 @@ test_main(void)
 			"00000000 00000000 00000000 00000000"
 			"00000000 00000000 00000000 00000000"
 			"00000000 00000000 00000000 00000000"
-			"00000000 00000000 00000000 00000000"),
-		     H("a2b35dc7 bf95ae1e 1c432d15 f4fb8c1c"
+			"00000000 00000000 00000000 00000000",
+		     "a2b35dc7 bf95ae1e 1c432d15 f4fb8c1c"
 		       "f264e1d0 bd090831 6caa7d17 5401ae67"
 		       "3cfbd140 fd3dee42 1012d674 2fb69fa3"
 		       "6522631e bb3d4703 535de1ce 4a81ddce"
@@ -91,7 +91,7 @@ test_main(void)
 		       "613e3067 92cada3e 0e07f599 2f4794f3"
 		       "af01f15a 491732fb 22aa09a3 d2e1e408"
 		       "fe94bdb4 993c68b1 1bb79eb1 bb7ec446"
-		       "760ef7bf 2caa8713 479760e5 a6e143cd"));
+		       "760ef7bf 2caa8713 479760e5 a6e143cd");
   
   SUCCESS();
 }
diff --git a/testsuite/arctwo-test.c b/testsuite/arctwo-test.c
index 4fedfad..cf52d1b 100644
--- a/testsuite/arctwo-test.c
+++ b/testsuite/arctwo-test.c
@@ -25,12 +25,16 @@
 /* For tests with obscure values of ebk. */
 static void
 test_arctwo(unsigned ekb,
-	    unsigned key_length,
-	    const uint8_t *key,
-	    unsigned length,
-	    const uint8_t *cleartext,
-	    const uint8_t *ciphertext)
+	    const uint8_t *key_hex,
+	    const uint8_t *cleartext_hex,
+	    const uint8_t *ciphertext_hex)
 {
+  unsigned key_length = decode_hex_length(key_hex);
+  const uint8_t *key = decode_hex_dup(key_hex);
+  unsigned length = decode_hex_length(cleartext_hex);
+  const uint8_t *cleartext = decode_hex_dup(cleartext_hex);
+  const uint8_t *ciphertext = decode_hex_dup(ciphertext_hex);
+
   struct arctwo_ctx ctx;
   uint8_t *data = xalloc(length);
 
@@ -46,6 +50,9 @@ test_arctwo(unsigned ekb,
     FAIL();
 
   free(data);
+  free((void *)ciphertext);
+  free((void *)cleartext);
+  free((void *)key);
 }
 
 int
@@ -53,63 +60,63 @@ test_main(void)
 {
   /* Test vectors from Peter Gutmann's paper. */
   test_cipher(&nettle_arctwo_gutmann128,
-	      HL("00000000 00000000 00000000 00000000"),
-	      HL("00000000 00000000"),
-	      H ("1c198a83 8df028b7"));
+	      "00000000 00000000 00000000 00000000",
+	      "00000000 00000000",
+	      "1c198a83 8df028b7");
 
   test_cipher(&nettle_arctwo_gutmann128,
-	      HL("00010203 04050607 08090a0b 0c0d0e0f"),
-	      HL("00000000 00000000"),
-	      H ("50dc0162 bd757f31"));
+	      "00010203 04050607 08090a0b 0c0d0e0f",
+	      "00000000 00000000",
+	      "50dc0162 bd757f31");
 
   /* This one was checked against libmcrypt's RFC2268. */
   test_cipher(&nettle_arctwo_gutmann128,
-	      HL("30000000 00000000 00000000 00000000"),
-	      HL("10000000 00000000"),
-	      H ("8fd10389 336bf95e"));
+	      "30000000 00000000 00000000 00000000",
+	      "10000000 00000000",
+	      "8fd10389 336bf95e");
 
   /* Test vectors from RFC 2268. */
   test_cipher(&nettle_arctwo64,
-	      HL("ffffffff ffffffff"),
-	      HL("ffffffff ffffffff"),
-	      H ("278b27e4 2e2f0d49"));
+	      "ffffffff ffffffff",
+	      "ffffffff ffffffff",
+	      "278b27e4 2e2f0d49");
 
   test_cipher(&nettle_arctwo64,
-	      HL("30000000 00000000"),
-	      HL("10000000 00000001"),
-	      H ("30649edf 9be7d2c2"));
+	      "30000000 00000000",
+	      "10000000 00000001",
+	      "30649edf 9be7d2c2");
 
   test_cipher(&nettle_arctwo128,
-	      HL("88bca90e 90875a7f 0f79c384 627bafb2"),
-	      HL("00000000 00000000"),
-	      H ("2269552a b0f85ca6"));
+	      "88bca90e 90875a7f 0f79c384 627bafb2",
+	      "00000000 00000000",
+	      "2269552a b0f85ca6");
 
   /* More obscure tests from RFC 2286 */
   test_arctwo(63,
-	      HL("00000000 00000000"),
-	      HL("00000000 00000000"),
-	      H ("ebb773f9 93278eff"));
+	      "00000000 00000000",
+	      "00000000 00000000",
+	      "ebb773f9 93278eff");
 
   test_arctwo(64,
-	      HL("88"),
-	      HL("00000000 00000000"),
-	      H ("61a8a244 adacccf0"));
+	      "88",
+	      "00000000 00000000",
+	      "61a8a244 adacccf0");
 
   test_arctwo(64,
-	      HL("88bca90e 90875a"),
-	      HL("00000000 00000000"),
-	      H ("6ccf4308 974c267f"));
+	      "88bca90e 90875a",
+	      "00000000 00000000",
+	      "6ccf4308 974c267f");
 
   test_arctwo(64,
-	      HL("88bca90e 90875a7f 0f79c384 627bafb2"),
-	      HL("00000000 00000000"),
-	      H ("1a807d27 2bbe5db1"));
+	      "88bca90e 90875a7f 0f79c384 627bafb2",
+	      "00000000 00000000",
+	      "1a807d27 2bbe5db1");
 
   test_arctwo(129,
-	      HL("88bca90e 90875a7f 0f79c384 627bafb2"
-		 "16f80a6f 85920584 c42fceb0 be255daf 1e"),
-	      HL("00000000 00000000"),
-	      H ("5b78d3a4 3dfff1f1"));
+	      "88bca90e 90875a7f 0f79c384 627bafb2"
+		 "16f80a6f 85920584 c42fceb0 be255daf 1e",
+	      "00000000 00000000",
+	      "5b78d3a4 3dfff1f1");
 
   SUCCESS ();
 }
diff --git a/testsuite/bignum-test.c b/testsuite/bignum-test.c
index 84e0483..91afa9e 100644
--- a/testsuite/bignum-test.c
+++ b/testsuite/bignum-test.c
@@ -11,8 +11,10 @@
 #include "bignum.h"
 
 static void
-test_bignum(const char *hex, unsigned length, const uint8_t *base256)
+test_bignum(const char *hex, const uint8_t *base256_hex)
 {
+  unsigned length = decode_hex_length(base256_hex);
+  const uint8_t *base256 = decode_hex_dup(base256_hex);
   mpz_t a;
   mpz_t b;
   uint8_t *buf;
@@ -35,6 +37,7 @@ test_bignum(const char *hex, unsigned length, const uint8_t *base256)
 
   mpz_clear(a); mpz_clear(b);
   free(buf);
+  free((void *)base256);
 }
 
 static void
@@ -78,17 +81,17 @@ test_main(void)
   test_size(- 0x8000, 2); /*   8000 */
   test_size(- 0x8001, 3); /* ff7fff */
 
-  test_bignum("0", HL("00"));
-  test_bignum("010203040506", HL("010203040506"));
-  test_bignum("80010203040506", HL("0080010203040506"));
-
-  test_bignum(   "-1", HL(    "ff"));
-  test_bignum(  "-7f", HL(    "81"));
-  test_bignum(  "-80", HL(    "80"));
-  test_bignum(  "-81", HL(  "ff7f"));
-  test_bignum("-7fff", HL(  "8001"));
-  test_bignum("-8000", HL(  "8000"));
-  test_bignum("-8001", HL("ff7fff"));
+  test_bignum("0", "00");
+  test_bignum("010203040506", "010203040506");
+  test_bignum("80010203040506", "0080010203040506");
+
+  test_bignum(   "-1",     "ff");
+  test_bignum(  "-7f",     "81");
+  test_bignum(  "-80",     "80");
+  test_bignum(  "-81",   "ff7f");
+  test_bignum("-7fff",   "8001");
+  test_bignum("-8000",   "8000");
+  test_bignum("-8001", "ff7fff");
   
   SUCCESS();
 #else /* !HAVE_LIBGMP */
diff --git a/testsuite/blowfish-test.c b/testsuite/blowfish-test.c
index c4311bb..560f914 100644
--- a/testsuite/blowfish-test.c
+++ b/testsuite/blowfish-test.c
@@ -2,14 +2,22 @@
 #include "nettle-internal.h"
 #include "blowfish.h"
 
+#define STR_TO_HEX(a) encode_hex_dup(a, strlen(a))
+
 int
 test_main(void)
 {
+  const uint8_t *key_hex = STR_TO_HEX("abcdefghijklmnopqrstuvwxyz");
+  const uint8_t *cleartext_hex = STR_TO_HEX("BLOWFISH");
+
   /* 208 bit key. Test from GNUPG. */
   test_cipher(&nettle_blowfish128,
-	      26, "abcdefghijklmnopqrstuvwxyz",
-	      BLOWFISH_BLOCK_SIZE, "BLOWFISH",
-	      H("32 4E D0 FE F4 13 A2 03"));
+	      key_hex,
+	      cleartext_hex,
+	      "32 4E D0 FE F4 13 A2 03");
+
+  free((void *)cleartext_hex);
+  free((void *)key_hex);
 
   SUCCESS();
 }
diff --git a/testsuite/camellia-test.c b/testsuite/camellia-test.c
index 4f1d118..8e245a4 100644
--- a/testsuite/camellia-test.c
+++ b/testsuite/camellia-test.c
@@ -2,10 +2,16 @@
 #include "camellia.h"
 
 static void
-test_invert(unsigned key_length, const uint8_t *key,
-	    unsigned length, const uint8_t *cleartext,
-	    const uint8_t *ciphertext)
+test_invert(const uint8_t *key_hex,
+	    const uint8_t *cleartext_hex,
+	    const uint8_t *ciphertext_hex)
 {
+  unsigned key_length = decode_hex_length(key_hex);
+  const uint8_t *key = decode_hex_dup(key_hex);
+  unsigned length = decode_hex_length(cleartext_hex);
+  const uint8_t *cleartext = decode_hex_dup(cleartext_hex);
+  const uint8_t *ciphertext = decode_hex_dup(ciphertext_hex);
+
   struct camellia_ctx encrypt;
   struct camellia_ctx decrypt;
   uint8_t *data = xalloc(length);
@@ -39,7 +45,11 @@ test_invert(unsigned key_length, const uint8_t *key,
       fprintf(stderr, "\n");
       FAIL();
     }
+
   free (data);
+  free((void *)ciphertext);
+  free((void *)cleartext);
+  free((void *)key);
 }
 
 int
@@ -48,37 +58,37 @@ test_main(void)
   /* Test vectors from RFC 3713 */
   /* 128 bit keys */
   test_cipher(&nettle_camellia128,
-	      HL("01 23 45 67 89 ab cd ef fe dc ba 98 76 54 32 10"),
-	      HL("01 23 45 67 89 ab cd ef fe dc ba 98 76 54 32 10"),
-	      H("67 67 31 38 54 96 69 73 08 57 06 56 48 ea be 43"));
+	      "01 23 45 67 89 ab cd ef fe dc ba 98 76 54 32 10",
+	      "01 23 45 67 89 ab cd ef fe dc ba 98 76 54 32 10",
+	      "67 67 31 38 54 96 69 73 08 57 06 56 48 ea be 43");
 
   /* 192 bit keys */
   test_cipher(&nettle_camellia192, 
-	      HL("01 23 45 67 89 ab cd ef fe dc ba 98 76 54 32 10"
-                 "00 11 22 33 44 55 66 77"),
-	      HL("01 23 45 67 89 ab cd ef fe dc ba 98 76 54 32 10"),
-	      H("b4 99 34 01 b3 e9 96 f8 4e e5 ce e7 d7 9b 09 b9"));
+	      "01 23 45 67 89 ab cd ef fe dc ba 98 76 54 32 10"
+                 "00 11 22 33 44 55 66 77",
+	      "01 23 45 67 89 ab cd ef fe dc ba 98 76 54 32 10",
+	      "b4 99 34 01 b3 e9 96 f8 4e e5 ce e7 d7 9b 09 b9");
 
   /* 256 bit keys */
   test_cipher(&nettle_camellia256, 
-	      HL("01 23 45 67 89 ab cd ef fe dc ba 98 76 54 32 10"
-                 "00 11 22 33 44 55 66 77 88 99 aa bb cc dd ee ff"),
-	      HL("01 23 45 67 89 ab cd ef fe dc ba 98 76 54 32 10"),
-	      H("9a cc 23 7d ff 16 d7 6c 20 ef 7c 91 9e 3a 75 09"));
+	      "01 23 45 67 89 ab cd ef fe dc ba 98 76 54 32 10"
+                 "00 11 22 33 44 55 66 77 88 99 aa bb cc dd ee ff",
+	      "01 23 45 67 89 ab cd ef fe dc ba 98 76 54 32 10",
+	      "9a cc 23 7d ff 16 d7 6c 20 ef 7c 91 9e 3a 75 09");
 
   /* Test camellia_invert_key with src != dst */
-  test_invert(HL("01 23 45 67 89 ab cd ef fe dc ba 98 76 54 32 10"),
-	      HL("01 23 45 67 89 ab cd ef fe dc ba 98 76 54 32 10"),
-	      H("67 67 31 38 54 96 69 73 08 57 06 56 48 ea be 43"));
+  test_invert("01 23 45 67 89 ab cd ef fe dc ba 98 76 54 32 10",
+	      "01 23 45 67 89 ab cd ef fe dc ba 98 76 54 32 10",
+	      "67 67 31 38 54 96 69 73 08 57 06 56 48 ea be 43");
   
-  test_invert(HL("01 23 45 67 89 ab cd ef fe dc ba 98 76 54 32 10"
-                 "00 11 22 33 44 55 66 77"),
-	      HL("01 23 45 67 89 ab cd ef fe dc ba 98 76 54 32 10"),
-	      H("b4 99 34 01 b3 e9 96 f8 4e e5 ce e7 d7 9b 09 b9"));
+  test_invert("01 23 45 67 89 ab cd ef fe dc ba 98 76 54 32 10"
+                 "00 11 22 33 44 55 66 77",
+	      "01 23 45 67 89 ab cd ef fe dc ba 98 76 54 32 10",
+	      "b4 99 34 01 b3 e9 96 f8 4e e5 ce e7 d7 9b 09 b9");
 
-  test_invert(HL("01 23 45 67 89 ab cd ef fe dc ba 98 76 54 32 10"
-                 "00 11 22 33 44 55 66 77 88 99 aa bb cc dd ee ff"),
-	      HL("01 23 45 67 89 ab cd ef fe dc ba 98 76 54 32 10"),
-	      H("9a cc 23 7d ff 16 d7 6c 20 ef 7c 91 9e 3a 75 09"));
+  test_invert("01 23 45 67 89 ab cd ef fe dc ba 98 76 54 32 10"
+                 "00 11 22 33 44 55 66 77 88 99 aa bb cc dd ee ff",
+	      "01 23 45 67 89 ab cd ef fe dc ba 98 76 54 32 10",
+	      "9a cc 23 7d ff 16 d7 6c 20 ef 7c 91 9e 3a 75 09");
   SUCCESS();
 }
diff --git a/testsuite/cast128-test.c b/testsuite/cast128-test.c
index e4b7830..e9d8fae 100644
--- a/testsuite/cast128-test.c
+++ b/testsuite/cast128-test.c
@@ -9,22 +9,22 @@ test_main(void)
 
   /* 128 bit key */
   test_cipher(&nettle_cast128,
-	      HL("01 23 45 67 12 34 56 78"
-		 "23 45 67 89 34 56 78 9A"),
-	      HL("01 23 45 67 89 AB CD EF"),
-	      H("23 8B 4F E5 84 7E 44 B2"));
+	      "01 23 45 67 12 34 56 78"
+		 "23 45 67 89 34 56 78 9A",
+	      "01 23 45 67 89 AB CD EF",
+	      "23 8B 4F E5 84 7E 44 B2");
   
   /* 80 bit key */
   test_cipher(&nettle_cast128,
-	      HL("01 23 45 67 12 34 56 78 23 45"),
-	      HL("01 23 45 67 89 AB CD EF"),
-	      H("EB 6A 71 1A 2C 02 27 1B"));
+	      "01 23 45 67 12 34 56 78 23 45",
+	      "01 23 45 67 89 AB CD EF",
+	      "EB 6A 71 1A 2C 02 27 1B");
 
   /* 40 bit key */
   test_cipher(&nettle_cast128,
-	      HL("01 23 45 67 12"),
-	      HL("01 23 45 67 89 AB CD EF"),
-	      H("7A C8 16 D1 6E 9B 30 2E"));
+	      "01 23 45 67 12",
+	      "01 23 45 67 89 AB CD EF",
+	      "7A C8 16 D1 6E 9B 30 2E");
 
   SUCCESS();
 }
diff --git a/testsuite/cbc-test.c b/testsuite/cbc-test.c
index b7bd2dd..d877775 100644
--- a/testsuite/cbc-test.c
+++ b/testsuite/cbc-test.c
@@ -68,13 +68,19 @@ test_cbc_bulk(void)
 
   if (!MEMEQ(CBC_BULK_DATA, clear, cipher))
     FAIL();
+
+  free((void *)end_iv);
+  free((void *)start_iv);
+  free((void *)key);
 }
 
 int
 test_main(void)
 {
   static const uint8_t msg[2 * AES_BLOCK_SIZE] = "Listen, I'll say this only once!";
-  
+
+  const uint8_t *msg_hex = encode_hex_dup(msg, sizeof(msg));
+
   /* Intermediate values:
    *   iv XOR first message block:
    *       "a5 ce 55 d4 21 15 a1 c6 4a a4 0c b2 ca a6 d1 37"
@@ -87,16 +93,18 @@ test_main(void)
    */
 
   test_cipher_cbc(&nettle_aes256,
-		  HL("8d ae 93 ff fc 78 c9 44"
+		  "8d ae 93 ff fc 78 c9 44"
 		     "2a bd 0c 1e 68 bc a6 c7"
 		     "05 c7 84 e3 5a a9 11 8b"
-		     "d3 16 aa 54 9b 44 08 9e"),
-		  2 * AES_BLOCK_SIZE, msg,
-		  H("1f 94 fc 85 f2 36 21 06"
+		     "d3 16 aa 54 9b 44 08 9e",
+		  msg_hex,
+		  "1f 94 fc 85 f2 36 21 06"
 		    "4a ea e3 c9 cc 38 01 0e"
 		    "7b f6 5f c5 02 59 2e 71"
-		    "af bf 34 87 c0 36 2a 16"),
-		  H("e9 a7 26 a0 44 7b 8d e6  03 83 60 de ea d5 b0 4e"));
+		    "af bf 34 87 c0 36 2a 16",
+		  "e9 a7 26 a0 44 7b 8d e6  03 83 60 de ea d5 b0 4e");
+
+  free((void *)msg_hex);
 
   /* From NIST spec 800-38a on AES modes.
    *
@@ -112,16 +120,16 @@ test_main(void)
    *   8521f2fd3c8eef2cdc3da7e5c44ea206 
    */
   test_cipher_cbc(&nettle_aes128,
-		  HL("2b7e151628aed2a6abf7158809cf4f3c"),
-		  HL("6bc1bee22e409f96e93d7e117393172a"
+		  "2b7e151628aed2a6abf7158809cf4f3c",
+		  "6bc1bee22e409f96e93d7e117393172a"
 		     "ae2d8a571e03ac9c9eb76fac45af8e51"
 		     "30c81c46a35ce411e5fbc1191a0a52ef"
-		     "f69f2445df4f9b17ad2b417be66c3710"),
-		  H("7649abac8119b246cee98e9b12e9197d"
+		     "f69f2445df4f9b17ad2b417be66c3710",
+		  "7649abac8119b246cee98e9b12e9197d"
 		    "5086cb9b507219ee95db113a917678b2"
 		    "73bed6b8e3c1743b7116e69e22229516"
-		    "3ff1caa1681fac09120eca307586e1a7"),
-		  H("000102030405060708090a0b0c0d0e0f"));
+		    "3ff1caa1681fac09120eca307586e1a7",
+		  "000102030405060708090a0b0c0d0e0f");
   
   /* F.2.3 CBC-AES192.Encrypt */
   
@@ -134,17 +142,17 @@ test_main(void)
    */
 
   test_cipher_cbc(&nettle_aes192,
-		  HL("8e73b0f7da0e6452c810f32b809079e5"
-		     "62f8ead2522c6b7b"),
-		  HL("6bc1bee22e409f96e93d7e117393172a"
+		  "8e73b0f7da0e6452c810f32b809079e5"
+		     "62f8ead2522c6b7b",
+		  "6bc1bee22e409f96e93d7e117393172a"
 		     "ae2d8a571e03ac9c9eb76fac45af8e51"
 		     "30c81c46a35ce411e5fbc1191a0a52ef"
-		     "f69f2445df4f9b17ad2b417be66c3710"),
-		  H("4f021db243bc633d7178183a9fa071e8"
+		     "f69f2445df4f9b17ad2b417be66c3710",
+		  "4f021db243bc633d7178183a9fa071e8"
 		    "b4d9ada9ad7dedf4e5e738763f69145a"
 		    "571b242012fb7ae07fa9baac3df102e0"
-		    "08b0e27988598881d920a9e64f5615cd"),
-		  H("000102030405060708090a0b0c0d0e0f"));
+		    "08b0e27988598881d920a9e64f5615cd",
+		  "000102030405060708090a0b0c0d0e0f");
    
   /* F.2.5 CBC-AES256.Encrypt */
 
@@ -157,17 +165,17 @@ test_main(void)
    */
 
   test_cipher_cbc(&nettle_aes256,
-		  HL("603deb1015ca71be2b73aef0857d7781"
-		     "1f352c073b6108d72d9810a30914dff4"),
-		  HL("6bc1bee22e409f96e93d7e117393172a"
+		  "603deb1015ca71be2b73aef0857d7781"
+		     "1f352c073b6108d72d9810a30914dff4",
+		  "6bc1bee22e409f96e93d7e117393172a"
 		     "ae2d8a571e03ac9c9eb76fac45af8e51"
 		     "30c81c46a35ce411e5fbc1191a0a52ef"
-		     "f69f2445df4f9b17ad2b417be66c3710"),
-		  H("f58c4c04d6e5f1ba779eabfb5f7bfbd6"
+		     "f69f2445df4f9b17ad2b417be66c3710",
+		  "f58c4c04d6e5f1ba779eabfb5f7bfbd6"
 		    "9cfc4e967edb808d679f777bc6702c7d"
 		    "39f23369a9d9bacfa530e26304231461"
-		    "b2eb05e2c39be9fcda6c19078c6a9d1b"),
-		  H("000102030405060708090a0b0c0d0e0f"));
+		    "b2eb05e2c39be9fcda6c19078c6a9d1b",
+		  "000102030405060708090a0b0c0d0e0f");
 
   test_cbc_bulk();
    
diff --git a/testsuite/ctr-test.c b/testsuite/ctr-test.c
index 15c74d5..6b3c3fa 100644
--- a/testsuite/ctr-test.c
+++ b/testsuite/ctr-test.c
@@ -14,43 +14,43 @@ test_main(void)
 
   /* F.5.1  CTR-AES128.Encrypt */
   test_cipher_ctr(&nettle_aes128,
-		  HL("2b7e151628aed2a6abf7158809cf4f3c"),
-		  HL("6bc1bee22e409f96e93d7e117393172a"
+		  "2b7e151628aed2a6abf7158809cf4f3c",
+		  "6bc1bee22e409f96e93d7e117393172a"
 		     "ae2d8a571e03ac9c9eb76fac45af8e51"
 		     "30c81c46a35ce411e5fbc1191a0a52ef"
-		     "f69f2445df4f9b17ad2b417be66c3710"),
-		  H("874d6191b620e3261bef6864990db6ce"
+		     "f69f2445df4f9b17ad2b417be66c3710",
+		  "874d6191b620e3261bef6864990db6ce"
 		    "9806f66b7970fdff8617187bb9fffdff"
 		    "5ae4df3edbd5d35e5b4f09020db03eab"
-		    "1e031dda2fbe03d1792170a0f3009cee"),
-		  H("f0f1f2f3f4f5f6f7f8f9fafbfcfdfeff"));
+		    "1e031dda2fbe03d1792170a0f3009cee",
+		  "f0f1f2f3f4f5f6f7f8f9fafbfcfdfeff");
 
   /* F.5.3  CTR-AES192.Encrypt */
   test_cipher_ctr(&nettle_aes192,
-		  HL("8e73b0f7da0e6452c810f32b809079e562f8ead2522c6b7b"),
-		  HL("6bc1bee22e409f96e93d7e117393172a"
+		  "8e73b0f7da0e6452c810f32b809079e562f8ead2522c6b7b",
+		  "6bc1bee22e409f96e93d7e117393172a"
 		     "ae2d8a571e03ac9c9eb76fac45af8e51"
 		     "30c81c46a35ce411e5fbc1191a0a52ef"
-		     "f69f2445df4f9b17ad2b417be66c3710"),
-		  H("1abc932417521ca24f2b0459fe7e6e0b"
+		     "f69f2445df4f9b17ad2b417be66c3710",
+		  "1abc932417521ca24f2b0459fe7e6e0b"
 		     "090339ec0aa6faefd5ccc2c6f4ce8e94"
 		     "1e36b26bd1ebc670d1bd1d665620abf7"
-		     "4f78a7f6d29809585a97daec58c6b050"),
-		  H("f0f1f2f3f4f5f6f7f8f9fafbfcfdfeff"));
+		     "4f78a7f6d29809585a97daec58c6b050",
+		  "f0f1f2f3f4f5f6f7f8f9fafbfcfdfeff");
 
   /* F.5.5  CTR-AES256.Encrypt */
   test_cipher_ctr(&nettle_aes256,
-		  HL("603deb1015ca71be2b73aef0857d7781"
-		     "1f352c073b6108d72d9810a30914dff4"),
-		  HL("6bc1bee22e409f96e93d7e117393172a"
+		  "603deb1015ca71be2b73aef0857d7781"
+		     "1f352c073b6108d72d9810a30914dff4",
+		  "6bc1bee22e409f96e93d7e117393172a"
 		     "ae2d8a571e03ac9c9eb76fac45af8e51"
 		     "30c81c46a35ce411e5fbc1191a0a52ef"
-		     "f69f2445df4f9b17ad2b417be66c3710"),
-		  H("601ec313775789a5b7a7f504bbf3d228"
+		     "f69f2445df4f9b17ad2b417be66c3710",
+		  "601ec313775789a5b7a7f504bbf3d228"
 		     "f443e3ca4d62b59aca84e990cacaf5c5"
 		     "2b0930daa23de94ce87017ba2d84988d"
-		     "dfc9c58db67aada613c2dd08457941a6"),
-		  H("f0f1f2f3f4f5f6f7f8f9fafbfcfdfeff"));
+		     "dfc9c58db67aada613c2dd08457941a6",
+		  "f0f1f2f3f4f5f6f7f8f9fafbfcfdfeff");
 
   SUCCESS();
 }
diff --git a/testsuite/cxx-test.cxx b/testsuite/cxx-test.cxx
index b5635fb..4411956 100644
--- a/testsuite/cxx-test.cxx
+++ b/testsuite/cxx-test.cxx
@@ -10,15 +10,18 @@ test_main(void)
 {
   struct md5_ctx md5;
   uint8_t digest[MD5_DIGEST_SIZE];
+  const uint8_t *result;
 
   md5_init (&md5);
   md5_update (&md5, 14, reinterpret_cast<const uint8_t *> ("message digest"));
   md5_digest (&md5, MD5_DIGEST_SIZE, digest);
 
-  if (!MEMEQH (MD5_DIGEST_SIZE, digest,
-	       "F96B697D7CB7938D 525A2F31AAF161D0"))
+  result = decode_hex_dup("F96B697D7CB7938D 525A2F31AAF161D0");
+  if (!MEMEQ (MD5_DIGEST_SIZE, digest, result))
     FAIL();
 
+  free((void *)result);
+
 #if WITH_PUBLIC_KEY
 
   struct rsa_public_key pub;
